__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a8"
__cvsversion__ = "$Revision: 1.4 $"
__date__       = "$Date: 2004/11/09 15:15:52 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rDisplay.py,v 1.4 2004/11/09 15:15:52 asc Exp $

from rConstants  import *
from rPanel      import rPanel
from rConfig     import rConfig
from rPrefs      import rPrefs
from rError      import rNoService
from rBloom      import rBloom
from rLog        import rLog

import wx
from cStringIO   import StringIO

from xmlrpclib import Server
from os        import name
from sys       import platform
from os.path   import isdir,isfile,join
from random    import choice

ID_DISPLAY_PAUSE     = wx.NewId()
ID_DISPLAY_RESUME    = wx.NewId()
ID_DISPLAY_MAXWIDTH  = wx.NewId()
ID_DISPLAY_MAXHEIGHT = wx.NewId()
ID_DISPLAY_INFO      = wx.NewId()
ID_DISPLAY_LOG       = wx.NewId()
ID_DISPLAY_PREFS     = wx.NewId()
ID_DISPLAY_ABOUT     = wx.NewId()
ID_DISPLAY_EXIT      = wx.NewId()

class rDisplay(wx.Frame):

    def __init__(self, parent, ID, title):

        #
        
        cfg          = join(USER_HOMEDIR,".rImage.xml")
        self.Config  = rConfig(cfg)
        
        self.LoadConfig()

        #
        
        self.Logger = None
        
        #
        
        app = self.Config.App()

        # this is kind of ugly...
        # to reconsider...
        
        max_x = NS_W5 + W5_APP_MAXWIDTH
        max_y = NS_W5 + W5_APP_MAXHEIGHT

        pos_x = NS_W5 + W5_APP_POSX
        pos_y = NS_W5 + W5_APP_POSY
        
        # set initial height for window
        
        if app.has_key(max_y) and int(app[max_y]) > 0:
            self.MaxHeight = int(app[max_y])
        else:
            max_y = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_Y)
            self.MaxHeight = int(int(max_y * .75) / 2)
        
        if app.has_key(max_x) and int(app[max_x]) > 0:
            self.MaxWidth  = int(app[max_x])
        else:
            max_x = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_X)
            self.MaxWidth = int(int(max_x * .75) / 2)

        # set initial position for window
        
        if app.has_key(pos_x) and app.has_key(pos_y) \
           and int(app[pos_x]) > 0 and int(app[pos_y]) :

            pos = wx.Point(int(app[pos_x]),
                          int(app[pos_y]))
            
        else:
            pos = wx.DefaultPosition

        # Check to see if w/y is greater than
        # screen or just assume the user knows
        # what they're doing...

        wx.Frame.__init__(self, parent, ID, title,
                         pos,
			 wx.Size(self.MaxWidth,
				 self.MaxHeight))

        self.Panel   = rPanel(self, -1)

	#

        self.Data    = {}
        self.Image   = None
	self.Caption = None
	self.Paused  = False
	self.Offset     = 0

        FileMenu = wx.Menu()

        FileMenu.Append(ID_DISPLAY_PAUSE,
			MENU_PAUSE,
			DESCRIBE_PAUSE)
	
        FileMenu.Append(ID_DISPLAY_RESUME,
			MENU_RESUME,
			DESCRIBE_RESUME)
	
        FileMenu.AppendSeparator()
                        
        FileMenu.Append(ID_DISPLAY_EXIT,
			MENU_QUIT,
			DESCRIBE_QUIT)

        FileMenu.Enable(ID_DISPLAY_RESUME,False)

        EditMenu = wx.Menu()

	EditMenu.Append(ID_DISPLAY_MAXWIDTH,
			MENU_MAXWIDTH,
			DESCRIBE_MAXWIDTH)

	EditMenu.Append(ID_DISPLAY_MAXHEIGHT,
			MENU_MAXHEIGHT,
			DESCRIBE_MAXHEIGHT)

        EditMenu.AppendSeparator()

        EditMenu.Append(ID_DISPLAY_PREFS,
			MENU_PREFS,
			DESCRIBE_PREFS)

        ToolsMenu = wx.Menu()
        ToolsMenu.Append(ID_DISPLAY_INFO,
			 MENU_INFO,
	                 DESCRIBE_INFO)	

        ToolsMenu.AppendCheckItem(ID_DISPLAY_LOG,
                                  MENU_LOG,
                                  DESCRIBE_LOG)
        
        HelpMenu = wx.Menu()
        HelpMenu.Append(ID_DISPLAY_ABOUT,
			MENU_ABOUT,
	                DESCRIBE_ABOUT)
		    
        menuBar = wx.MenuBar()
        menuBar.Append(FileMenu,  MENUBAR_FILE);
        menuBar.Append(EditMenu,  MENUBAR_EDIT);
        menuBar.Append(ToolsMenu, MENUBAR_TOOLS);
        menuBar.Append(HelpMenu,  MENUBAR_HELP);

        self.SetMenuBar(menuBar)

        #
        
        logging = NS_W5 + W5_APP_LOGGING
        
        if app.has_key(logging) and app[logging] == "True" :
            ToolsMenu.Check(ID_DISPLAY_LOG,True)
            self.SetLogger(True)
        else :
            ToolsMenu.Check(ID_DISPLAY_LOG,False)

        #
        
	# 2.5 syntax, for future reference; old
	# skool code will still work
	# self.Bind(wx.EVT_MENU, self.OnExit, item)

        wx.EVT_MENU(self, ID_DISPLAY_PAUSE,     self.Pause)
        wx.EVT_MENU(self, ID_DISPLAY_RESUME,    self.Resume)
        wx.EVT_MENU(self, ID_DISPLAY_MAXWIDTH,  self.SetMaxWidth)
        wx.EVT_MENU(self, ID_DISPLAY_MAXHEIGHT, self.SetMaxHeight)
        wx.EVT_MENU(self, ID_DISPLAY_INFO,      self.Info)
        wx.EVT_MENU(self, ID_DISPLAY_LOG,       self.ToggleLogger)        
        wx.EVT_MENU(self, ID_DISPLAY_PREFS,     self.Services)
        wx.EVT_MENU(self, ID_DISPLAY_ABOUT,     self.About)
        wx.EVT_MENU(self, ID_DISPLAY_EXIT,      self.Quit)

        wx.EVT_CLOSE(self,self.Quit)
        
	# Doesn't appear to work under
	# py-wxPython (FreeBSD)
        wx.EVT_MENU_CLOSE(self,self.SetCaption)

	wx.EVT_KEY_DOWN(self.Panel, self.KeyDown)


        #

        self.CreateStatusBar()

    #

    def Setup (self) :
        self.Show(True)
        self.Panel.SetFocus()
	self.Offset = (self.GetSize())[1] - (self.Panel.GetSize())[1]

    #

    def Log (self,level,msg) :
        if self.Logger == None :
            return

        self.Logger.dispatch(level,msg)

    #

    def ToggleLogger (self,evt) :

        bool = None
        
        if self.Logger == None :
            bool = True
        else :
            bool = False

        return self.SetLogger(bool)

    #
    
    def SetLogger (self,bool) :

        if bool == False :
            self.ReportActivity(MSG_NOLOG)
            self.Log("info",MSG_NOLOG)
            self.Logger = None
            
        else :

            log = join(USER_HOMEDIR,".rImage.log")
            self.Logger = rLog(log,__name__)
            self.ReportActivity(MSG_LOG)

        #
        
        self.GetMenuBar().Check(ID_DISPLAY_LOG,bool)        
        self.Config.SetLogging(bool)
        
        return True

    #
    
    def LoadConfig(self):

        try :
            self.Config.Load()
            return self.Config
        except :
            return False    

    #
    
    def RandomService (self):
    
        try :
            url = choice(self.Config.ListServices([PROTOCOL_XMLRPC]))
        except :
            raise Exception, ERR_NOSERVICES

        try :
            service = self.Config.DescribeService(url)
        except :
            raise Exception, ERR_SERVICEINFO

        return service

    #
    
    def Yield(self):
        
        # This causes Windows to hang
        # FreeBSD hangs without it...

        if name == "nt":
            pass
        else:
            wx.SafeYield(self,True)

    #
    
    def ReportError(self,msg,inst=None):
        self.ReportActivity(msg)

        #
        
        if inst == None :
            inst = ERR_UNDEFINED
            
        error = "%s:\n%s\n" % (msg,inst)
        self.Log("error",error)
        
        dlg = wx.MessageDialog(self,error,
                              ERR_ERROR,wx.OK);

        dlg.ShowModal()
        dlg.Destroy()					

        self.Yield()

    #
    
    def ReportActivity(self,msg):
	return 
	if msg:
            self.SetStatusText("[%s]" % self.PrepareStatusText(msg))
	else: 
	   self.SetStatusText("")

        self.Yield()

    #
    
    def Services (self,event):

        prefs = rPrefs(self,-1,self.LoadConfig())

	(x,y) = self.GetPosition()
	prefs.SetPosition((x + 50,y + 50))
	prefs.Show()

    #
    
    def Pause(self,event):

        if self.Paused == True:
            return True
        
        self.Paused = True
        self.ReportActivity(MSG_PAUSED)
	
	self.GetMenuBar().Enable(ID_DISPLAY_PAUSE,False)
	self.GetMenuBar().Enable(ID_DISPLAY_RESUME,True)

    #
    
    def Resume(self,event):

        if self.Paused == False:
            return True
        
        self.Paused = False

	self.GetMenuBar().Enable(ID_DISPLAY_PAUSE,True)
	self.GetMenuBar().Enable(ID_DISPLAY_RESUME,False)

    #
    
    def KeyDown(self,event):

	if event.CmdDown():
            keycode = event.GetKeyCode()
        else:
            event.Skip()
            return True
        
        if keycode <= 256:
            keyname = chr(keycode)
        else:
            event.Skip()
            return True
        
	if keyname == KEY_DISPLAY_ABOUT :
            self.About(event)
        elif keyname == KEY_DISPLAY_MAXHEIGHT :
            self.SetMaxHeight(event)
        elif keyname == KEY_DISPLAY_INFO :
            self.Info(event)
        elif keyname == KEY_DISPLAY_LOG :
            self.ToggleLogger(event)            
        elif keyname == KEY_DISPLAY_PAUSE :
            self.Pause(event)
        elif keyname == KEY_DISPLAY_QUIT:
            self.Quit(event)
        elif keyname == KEY_DISPLAY_RESUME :
            self.Resume(event)
        elif keyname == KEY_DISPLAY_SERVICES :
            self.Services(event)            
        elif keyname == KEY_DISPLAY_MAXWIDTH :
            self.SetMaxWidth(event)
        else:
            event.Skip()
	
	return True

    #
    
    def About(self, event):
        dlg = wx.MessageDialog(self,
                              DIALOG_ABOUT,
                              TITLE_ABOUT,
			      wx.OK | wx.ICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    #
    
    def Info(self,event):

	if len(self.Data) == 0:
	   msg = ERR_IMAGEINFO
	else:
           msg = "%s\n" % (self.Data["who"])
           
           if self.Data["what"]:
               msg = "%s \"%s\"\n" % (msg,self.Data["what"])
              
           msg = "%s\n" % (msg)

           # god help me, there
           # *must* be a better
           # way...
           
           if self.Data["where"]:
               msg = "%s%s" % (msg,self.Data["where"])
              
           if self.Data["when"]:
               if self.Data["where"]:
                   msg = "%s, %s" % (msg,self.Data["when"])
               else:
                   msg = "%s%s" % (msg,self.Data["when"])
                   
        dlg = wx.MessageDialog(self,
                              msg,
                              TITLE_INFO,
			      wx.OK | wx.ICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    #
    
    def SetMaxWidth(self,event):
        max = wx.GetTextFromUser(DIALOG_MAXWIDTH_PROMPT,
				 DIALOG_MAXWIDTH_STATE % str(self.MaxWidth),
				 DIALOG_MAXWIDTH_SUBMIT)

        if max == "":
            return
        
        try:
            self.MaxWidth = int(max)
        except:
            errmsg = ERR_MAXWIDTH % str(max)
            self.ReportError(errmsg)
            return False
        
        self.Config.SetMaxWidth(self.MaxWidth)
    #

    def SetMaxHeight(self,event):
        max = wx.GetTextFromUser(DIALOG_MAXHEIGHT_PROMPT,
				DIALOG_MAXHEIGHT_STATE % str(self.MaxHeight),
	    	                DIALOG_MAXHEIGHT_SUBMIT)

        if max == "":
            return

        try:
            self.MaxHeight = int(max)
        except:
            errmsg = ERR_MAXHEIGHT % str(max)
            self.ReportError(errmsg)
            return False

        self.Config.SetMaxHeight(self.MaxHeight)

    #
    
    def Quit(self, event):

        # move all of this 
        # into self.__del__ ?
        
        (x,y) = self.GetPosition()

        self.Config.SetPositionX(x)
        self.Config.SetPositionY(y)
        
	# this is required by "nt"
	# and, I think, "os x"
	self.Panel.Destroy()

        self.Destroy()

    #
    
    def DisplayRandom(self):
    
        self.ReportActivity(MSG_POLLING)
    
        try:
            service = self.RandomService()
        except Exception, inst:
            self.ReportActivity(str(inst))
            raise rNoService, inst

	self.SetImage(service)

    def SetImage(self,service):
    
        self.Log("info", LOG_REQUEST_IMAGE % service.Endpoint())
        
	server = Server(service.Endpoint())
                            
        args   = {"release" : __version__,
                  "login"  : str(service.Login())}

        if service.Filter() :
            args["filter"] = str(service.Filter())

        #
        
        try:
            resp = server.w5.RandomImage(args)
        except Exception, inst:
            self.ReportError(ERR_POLLING, inst)
            return False

        self.ReportActivity(MSG_PROCESSING)

        try:
            data = StringIO(resp["image"].data)         
        except Exception, inst:
            self.ReportError(ERR_STRINGIFY, inst)
            return False

        try:
            image = wx.ImageFromStream(data)
        except Exception, inst:
            self.ReportError(ERR_STREAMIFY, inst)
            return False

	try:
	    scaled = self.ScaleImage(image)
	except Exception, inst :
            self.ReportError(ERR_SCALED, inst)
            return False

        try:
            self.Panel.Display(scaled)
	    
        except Exception, inst :
            self.ReportError(ERR_DISPLAY, inst)
            return False

	(img_x,img_y)  = scaled.GetSize()

	sz = wx.Size(img_x + (DIM_BORDER * 2),
		     img_y + (DIM_BORDER * 2) + self.Offset)

	self.SetSize(sz)

	self.Data["who"]   = resp["who"]
	self.Data["what"]  = resp["what"]
	self.Data["where"] = resp["where"]
	self.Data["when"]  = resp["when"]

	self.Data["uid"]   = None

        if resp.has_key("uid") :
            self.Data["uid"] = resp["uid"]
        
	if self.Data["what"]:
	   caption = "%s, %s" % (self.Data["who"],self.Data["what"])
	else:
	   caption = self.Data["who"]

	#

	caption = self.PrepareStatusText(caption,
					 int(image.GetWidth() * DIM_STATUSTEXT))

	self.Caption = caption
	self.SetCaption()

	# check for UID here and add to a bloom filter

        if self.Data["uid"] :
            self.Log("info", LOG_RECEIVE_IMAGE % self.Data["uid"]) 
            
	if self.Data["uid"] and service.Filter() :

	   filter = rBloom()
	   filter.fromstring_encoded(service.Filter())

           if filter.match(self.Data["uid"]) == True :
               self.Log("warn", LOG_DUPLICATE_IMAGE % self.Data["uid"])
           else :
               filter.add(str(self.Data["uid"]))
               service.Filter(filter.tostring_encoded())

               try :
                   self.Config.SetService(service.dict())
                   self.Config.Write()
               except Exception, inst :
                   self.Log("error",LOG_BF_FAIL % (self.Data["uid"],inst))

    #
    
    def SetCaption(self,event=None):
	if self.Caption:
	   self.SetStatusText(self.Caption)
	else:
	   self.SetStatusText("")

    #
    
    def PrepareStatusText(self,txt,max=0):

	# Okay, now we have to make sure that the
	# text will fit in the status bar
        
        (txt_x,txt_y) = self.GetTextExtent(txt)

	if max == 0:
	   max = int(self.GetSize()[0] * DIM_STATUSTEXT)

	if txt_x > max:

	   while txt_x > max:

		# please make the python keeners
		# shut the fuck up about how great
		# their language is. my kingdom for
		# a substring function...

		txt = txt[0:len(txt) - 1]

		# just in case

		if len(txt) == 1:
		   txt = ""
		   break

	        (txt_x,txt_y) = self.GetTextExtent(txt)

	   txt = "%s..." % txt
	
	#

	return txt

    #
    
    def ScaleImage(self,img):

        W = img.GetWidth()
        H = img.GetHeight()

	if W < self.MaxWidth and H < self.MaxHeight:
	   return img

        if W > H:
            NewW = self.MaxWidth
            NewH = self.MaxWidth * H / W
        else:
            NewH = self.MaxHeight
            NewW = self.MaxHeight * W / H

        return img.Scale(NewW,NewH)

    #
    
    def SetWindow(self,image):

	scr_x = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_X)
	scr_y = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_Y)

	(sb_x,sb_y)   = self.GetStatusBar().GetSize()
	(mb_x,mb_y)   = self.GetMenuBar().GetSize()
        
	(pos_x,pos_y) = self.GetPosition()

        # must find a way to measure
	# the width of the various
	# windowing border elements
        
        count_border_offset = 2.25
        width_border_side   = 3

        if name == "nt":
            count_border_offset *= 2
            width_border_side   *= 2.75

            # windows returns something
            # cracked like (999334,0)
            # this is a bug...
            
            mb_y = 25

        #
        
	img_x  = image.GetWidth()
        img_x += (DIM_BORDER * count_border_offset)

	img_y  = image.GetHeight()
        img_y += (DIM_BORDER * width_border_side)

	# no comment

	if name == "nt":
	   img_x -= 1

        #
        
	win_x = int(img_x)
	win_y = int(img_y + sb_y + mb_y)

	new_x = pos_x
	new_y = pos_y

	move  = False

	#

	if (pos_x + win_x) > scr_x:
	   new_x = scr_x - (win_x + (DIM_BORDER * count_border_offset))
	   move  = True

	if (pos_y + win_y) > scr_y:
	   new_y = scr_y - (win_y + (DIM_BORDER * count_border_offset))
	   move  = True

	if move:
	   self.SetPosition((new_x,new_y))   

	#

	self.SetSize(wx.Size(win_x,win_y))
