__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a8"
__cvsversion__ = "$Revision: 1.4 $"
__date__       = "$Date: 2004/11/09 15:15:52 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rEdit.py,v 1.4 2004/11/09 15:15:52 asc Exp $

import wx

from rConstants import *
from rBloom import rBloom

ID_EDITPREFS_ENDPOINT  = wx.NewId()
ID_EDITPREFS_TITLE     = wx.NewId()
ID_EDITPREFS_LOGIN     = wx.NewId()
ID_EDITPREFS_FILTER    = wx.NewId()
ID_EDITPREFS_OK        = wx.NewId()
ID_EDITPREFS_CANCEL    = wx.NewId()

class rEdit (wx.Frame) :

    def __init__ (self,parent,style,cfg,endpoint=None):

	self.__parent__   = parent

        self.__cfg__      = cfg
        self.__service__  = None
        self.__input__    = {"endpoint" : None,
			     "title"    : "",
                             "login"    : "",
			     "filter"   : ""}

        self.__controls__ = {}
        self.__ctrlkeys__ = []
        
        #
        
        if endpoint != None:
            self.__service__ = self.__cfg__.DescribeService(endpoint)

	    service = self.__service__.Title() or self.__service__.Endpoint()
            title   = TITLE_EDITSERVICE % (service)
        else:        
            title = TITLE_ADDSERVICE

        #
        
        wx.Frame.__init__(self,parent,style,title)
        (min_x,min_y) = self.GetBestSize()

        #

        # fs = self.GetFont().GetPointSize()
        # bf = wxFont(fs, wxSWISS, wxNORMAL, wxBOLD)

        #

        self.__addcontrol(wx.TextCtrl(self,ID_EDITPREFS_ENDPOINT,
                                     size = (min_x,-1)))
        
        self.__addcontrol(wx.TextCtrl(self,ID_EDITPREFS_TITLE,
                                     size = (min_x,-1)))
        
        self.__addcontrol(wx.TextCtrl(self,ID_EDITPREFS_LOGIN,
                                     size = (min_x,-1)))

        self.__addcontrol(wx.CheckBox(self,ID_EDITPREFS_FILTER,
                                     LABEL_FILTER))
        
        self.__addcontrol(wx.Button(self,ID_EDITPREFS_OK,
                                   LABEL_OK))
        
        self.__addcontrol(wx.Button(self,ID_EDITPREFS_CANCEL,
                                   LABEL_CANCEL))
        
        #

        spacer = wx.Size(5,5)
        
        sz_required = wx.StaticBoxSizer(wx.StaticBox(self,-1,LABEL_REQUIRED),
                                       wx.VERTICAL)

        sz_required.Add(spacer)
	sz_required.Add(wx.StaticText(self,-1,LABEL_ENDPOINT),
			0,wx.ALIGN_RIGHT)
        sz_required.Add(self.__controls__[ID_EDITPREFS_ENDPOINT])

        #

        sz_optional = wx.StaticBoxSizer(wx.StaticBox(self,-1,LABEL_OPTIONAL),
					wx.VERTICAL)
        sz_optional.Add(spacer)

	sz_optional.Add(wx.StaticText(self,-1,LABEL_TITLE),
                        0,wx.ALIGN_RIGHT)
        sz_optional.Add(self.__controls__[ ID_EDITPREFS_TITLE ])
        sz_optional.Add(spacer)

	sz_optional.Add(wx.StaticText(self,-1,LABEL_LOGIN),
                        0,wx.ALIGN_RIGHT)        
        sz_optional.Add(self.__controls__[ID_EDITPREFS_LOGIN])
        sz_optional.Add(spacer)

        sz_optional.Add(self.__controls__[ID_EDITPREFS_FILTER])
                
        sz_control  = wx.BoxSizer(wx.HORIZONTAL)

        sz_control.Add(self.__controls__[ID_EDITPREFS_OK])
        sz_control.Add(spacer)
        sz_control.Add(self.__controls__[ID_EDITPREFS_CANCEL])
        
        #

        sz_body = wx.BoxSizer(wx.VERTICAL)         

        sz_body.Add(sz_required)
        sz_body.Add(spacer)        
        sz_body.Add(sz_optional)

        sz_body.Add(spacer)
        sz_body.Add(spacer)
        
        sz_body.Add(sz_control,0,wx.ALIGN_RIGHT)

        sz_padding = wx.BoxSizer(wx.HORIZONTAL)
        sz_padding.Add(spacer)
        sz_padding.Add(sz_body)
        sz_padding.Add(spacer)

        sz_main = wx.BoxSizer(wx.VERTICAL)
        sz_main.Add(spacer)
        sz_main.Add(sz_padding)
        sz_main.Add(spacer)

	self.SetupInputs()
        
        #
        
	self.SetSizer(sz_main)
        self.SetAutoLayout(1)        

        self.CreateStatusBar()
        sz_main.Fit(self)

        self.__controls__[ID_EDITPREFS_ENDPOINT].SetFocus()
        self.__controls__["current"] = 0
        
        #
        
	wx.EVT_BUTTON(self, ID_EDITPREFS_OK, self.OK)
        wx.EVT_BUTTON(self, ID_EDITPREFS_CANCEL, self.Cancel)

        wx.EVT_TEXT(self,ID_EDITPREFS_ENDPOINT, self.__endpoint)
        wx.EVT_TEXT(self,ID_EDITPREFS_LOGIN, self.__login)
        wx.EVT_TEXT(self,ID_EDITPREFS_TITLE, self.__title)

        wx.EVT_CHECKBOX(self,ID_EDITPREFS_FILTER, self.__filter)

	# wx.EVT_KEY_DOWN(self, self.KeyDown)
	self.Bind(wx.EVT_KEY_DOWN, self.KeyDown)

    #
    
    def SetupInputs (self) :
        if  self.__service__ != None:

            self.__input__["endpoint"] = self.__service__.Endpoint()
            self.__controls__[ID_EDITPREFS_ENDPOINT].SetValue(self.__input__["endpoint"])

            if self.__service__.Title() != None and \
               self.__service__.Title() != self.__service__.Endpoint() :

                self.__input__["title"] = self.__service__.Title()
                self.__controls__[ID_EDITPREFS_TITLE].SetValue(self.__input__["title"])

            if self.__service__.Login() != None:
                self.__input__["login"] = self.__service__.Login()
                self.__controls__[ID_EDITPREFS_LOGIN].SetValue(self.__input__["login"])
                
            if self.__service__.Filter() != None:

                self.__input__["filter"] = self.__service__.Filter()
                self.__controls__[ID_EDITPREFS_FILTER].SetValue(1)

    #

    def __endpoint (self,event):
        self.__input__["endpoint"] = event.GetString()

    #
    
    def __login (self,event):
        self.__input__["login"] = event.GetString()

    #
    
    def __title (self,event):
        self.__input__["title"] = event.GetString()

    #
    
    def __filter (self,event):

        if event.IsChecked() :
            if self.__input__["filter"] == None:
                filter = rBloom()
                self.__input__["filter"] = filter.tostring_encoded()
        else :
            self.__input__["filter"] = None

    #
    
    def KeyDown (self,event):

	keycode = event.GetKeyCode()

        if keycode == WXK_TAB :

            cur   = self.__controls__["current"]
            count = len(self.__ctrlkeys__) - 1

            #
            
	    if event.ShiftDown() :
                if cur == 0 :
                    cur = count
                else :
                    cur = cur - 1
	    else :
                if cur >= count :
                    cur = 0
                else :
                    cur = cur + 1

            #
            
            id  = self.__ctrlkeys__[ cur ]

            self.__controls__["current"] = cur            
            self.__controls__[ id ].SetFocus()

        elif keycode == WXK_RETURN :

            cur = self.__controls__["current"]
            id  = self.__ctrlkeys__[ cur ]
            
            if id == ID_EDITPREFS_OK:
                self.OK(event)
            elif id == ID_EDITPREFS_CANCEL:
                self.Cancel(event)
            else:
                pass

        else :
            pass
        
    #
    
    def OK (self,event):

        if self.__input__["endpoint"] == None:
            self.Error("You must supply an endpoint.")
            return false
        
        #

        if self.__service__ == None :
            self.__cfg__.AddService(self.__input__)
        else :
            self.__cfg__.SetService(self.__input__)

        #

        try :
            self.__cfg__.Write()
        except Exception, inst :
            self.GetParent().ReportError(ERR_SAVECONFIG,inst)
            self.Destroy()
            
        # YA hack -- I need to figure out how to
        # get this to be called automagically in
        # rPrefs.py when the rEdit frame is destroyed
        
        self.GetParent().LoadServices()
        self.GetParent().Selected(self.__input__["endpoint"])
	self.GetParent().EnableControls()

	self.Destroy()

    #
    
    def Cancel (self,event):
	self.GetParent().EnableControls()
        self.Destroy()

    #
    
    def Error (self,msg) :
        dlg = wx.MessageDialog(self,
                              msg,
                              ERR_ERROR,
			      wx.OK | wx.ICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    #
    
    def __addcontrol (self,ctrl) :

        id = ctrl.GetId()
        
        self.__controls__[ id ] = ctrl
        self.__ctrlkeys__.append(id)
