__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a8"
__cvsversion__ = "$Revision: 1.2 $"
__date__       = "$Date: 2004/11/09 15:15:52 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rLog.py,v 1.2 2004/11/09 15:15:52 asc Exp $

import logging
import logging.handlers

from rConstants import MSG_LOG, MSG_NOLOG

class rLog :
      
    def __init__ (self,log,name,min_level=logging.INFO) :

        self.Logger = logging.getLogger(name)
            
        formatter = logging.Formatter('%(asctime)s %(levelname)s %(message)s')
        
        handler   = logging.handlers.RotatingFileHandler(log,
                                                         "a",
                                                         (1024 * 1024),
                                                         3)

        handler.setFormatter(formatter)
        
        self.Logger.addHandler(handler)
        self.Logger.setLevel(min_level)
        
        self.dispatch("info",MSG_LOG)
                
    def dispatch (self,event,msg) :
        logger = getattr(self.Logger, event)
        return logger(msg)
