__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a8"
__cvsversion__ = "$Revision: 1.3 $"
__date__       = "$Date: 2004/11/09 15:15:52 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rService.py,v 1.3 2004/11/09 15:15:52 asc Exp $

from rdflib.Namespace import Namespace
from rConstants import NS_W5, NS_DUBLINCORE, W5_PREFIX,DC_PREFIX

class rService:

    def __init__ (self,service,attrs={}) :

        self.__endpoint__ = service
        self.__attrs__    = attrs

        self.__ns__       = {}
        self.__ns__[W5_PREFIX] = Namespace(NS_W5)
        self.__ns__[DC_PREFIX] = Namespace(NS_DUBLINCORE)

    def dict (self) :
        return {"endpoint" : self.Endpoint(),
                "title"    : self.Title(),
                "login"    : self.Login(),
                "filter"   : self.Filter()}
                
    def Endpoint (self) :
        return self.__endpoint__

    def Title (self,title="") :

        title = self.__dc__("title",title)

        if title :
            return title
        else :
            return ""
        
    def Login (self,login="") :
        return self.__w5__("login",login)

    def Filter (self,filter="") :
        return self.__w5__("filter",filter)

    def __w5__ (self,attr,value) :
	return self.__nslookup__(W5_PREFIX,attr,value)

    def __dc__ (self,attr,value) :
	return self.__nslookup__(DC_PREFIX,attr,value)

    def __nslookup__ (self,ns,attr,value) :
        attr = self.__ns__[ns][attr]

        if self.__attrs__.has_key(attr):
            pass
        else :
            self.__attrs__[attr] = None

        if value :
            self.__attrs__[attr] = value
            
        return self.__attrs__[attr]
